package com.company.sample.screen.order;

import io.jmix.audit.entity.EntityLogAttr;
import io.jmix.audit.entity.EntityLogItem;
import io.jmix.core.MessageTools;
import io.jmix.core.Messages;
import io.jmix.core.Metadata;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.model.InstanceLoader;
import io.jmix.ui.screen.*;
import com.company.sample.entity.Order;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("Order_.edit")
@UiDescriptor("order-edit.xml")
@EditedEntityContainer("orderDc")
public class OrderEdit extends StandardEditor<Order> {

    @Autowired
    private CollectionLoader<EntityLogItem> entityLogItemsDl;

    @Autowired
    private MessageTools messageTools;

    @Autowired
    private InstanceContainer<Order> orderDc;

    @Subscribe(id = "orderDc", target = Target.DATA_CONTAINER)
    public void onOrderDcItemChange(InstanceContainer.ItemChangeEvent<Order> event) {
        Order order = event.getItem();
        if (order != null) {
            entityLogItemsDl.setParameter("orderId", order.getId());
            entityLogItemsDl.load();
        }
    }

    @Install(to = "attrTable.name", subject = "valueProvider")
    private String attrTableNameValueProvider(EntityLogAttr entityLogAttr) {
        return messageTools.getPropertyCaption(orderDc.getEntityMetaClass(), entityLogAttr.getName());
    }
}